org.objectweb.asm.commons

## Class InstructionAdapter

- java.lang.Object
- - org.objectweb.asm.MethodVisitor
  - - org.objectweb.asm.commons.InstructionAdapter

-     public class InstructionAdapter
      extends MethodVisitor

  A `MethodVisitor` providing a more detailed API to generate and transform instructions.
  Author:
    Eric Bruneton

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Type` | `OBJECT_TYPE`

    - ### Fields inherited from class org.objectweb.asm.MethodVisitor

      `api, mv`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `InstructionAdapter(int api, MethodVisitor mv)` Creates a new `InstructionAdapter`.
    `` | `InstructionAdapter(MethodVisitor mv)` Creates a new `InstructionAdapter`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `aconst(Object cst)`
    `void` | `add(Type type)`
    `void` | `aload(Type type)`
    `void` | `and(Type type)`
    `void` | `anew(Type type)`
    `void` | `areturn(Type t)`
    `void` | `arraylength()`
    `void` | `astore(Type type)`
    `void` | `athrow()`
    `void` | `cast(Type from, Type to)`
    `void` | `checkcast(Type type)`
    `void` | `cmpg(Type type)`
    `void` | `cmpl(Type type)`
    `void` | `dconst(double cst)`
    `void` | `div(Type type)`
    `void` | `dup()`
    `void` | `dup2()`
    `void` | `dup2X1()`
    `void` | `dup2X2()`
    `void` | `dupX1()`
    `void` | `dupX2()`
    `void` | `fconst(float cst)`
    `void` | `getfield(String owner, String name, String desc)`
    `void` | `getstatic(String owner, String name, String desc)`
    `void` | `goTo(Label label)`
    `void` | `hconst(Handle handle)`
    `void` | `iconst(int cst)`
    `void` | `ifacmpeq(Label label)`
    `void` | `ifacmpne(Label label)`
    `void` | `ifeq(Label label)`
    `void` | `ifge(Label label)`
    `void` | `ifgt(Label label)`
    `void` | `ificmpeq(Label label)`
    `void` | `ificmpge(Label label)`
    `void` | `ificmpgt(Label label)`
    `void` | `ificmple(Label label)`
    `void` | `ificmplt(Label label)`
    `void` | `ificmpne(Label label)`
    `void` | `ifle(Label label)`
    `void` | `iflt(Label label)`
    `void` | `ifne(Label label)`
    `void` | `ifnonnull(Label label)`
    `void` | `ifnull(Label label)`
    `void` | `iinc(int var, int increment)`
    `void` | `instanceOf(Type type)`
    `void` | `invokedynamic(String name, String desc, Handle bsm, Object[] bsmArgs)`
    `void` | `invokeinterface(String owner, String name, String desc)`
    `void` | `invokespecial(String owner, String name, String desc)` Deprecated.
    `void` | `invokespecial(String owner, String name, String desc, boolean itf)`
    `void` | `invokestatic(String owner, String name, String desc)` Deprecated.
    `void` | `invokestatic(String owner, String name, String desc, boolean itf)`
    `void` | `invokevirtual(String owner, String name, String desc)` Deprecated.
    `void` | `invokevirtual(String owner, String name, String desc, boolean itf)`
    `void` | `jsr(Label label)`
    `void` | `lcmp()`
    `void` | `lconst(long cst)`
    `void` | `load(int var, Type type)`
    `void` | `lookupswitch(Label dflt, int[] keys, Label[] labels)`
    `void` | `mark(Label label)`
    `void` | `monitorenter()`
    `void` | `monitorexit()`
    `void` | `mul(Type type)`
    `void` | `multianewarray(String desc, int dims)`
    `void` | `neg(Type type)`
    `void` | `newarray(Type type)`
    `void` | `nop()`
    `void` | `or(Type type)`
    `void` | `pop()`
    `void` | `pop2()`
    `void` | `putfield(String owner, String name, String desc)`
    `void` | `putstatic(String owner, String name, String desc)`
    `void` | `rem(Type type)`
    `void` | `ret(int var)`
    `void` | `shl(Type type)`
    `void` | `shr(Type type)`
    `void` | `store(int var, Type type)`
    `void` | `sub(Type type)`
    `void` | `swap()`
    `void` | `tableswitch(int min, int max, Label dflt, Label... labels)`
    `void` | `tconst(Type type)`
    `void` | `ushr(Type type)`
    `void` | `visitFieldInsn(int opcode, String owner, String name, String desc)` Visits a field instruction.
    `void` | `visitIincInsn(int var, int increment)` Visits an IINC instruction.
    `void` | `visitInsn(int opcode)` Visits a zero operand instruction.
    `void` | `visitIntInsn(int opcode, int operand)` Visits an instruction with a single int operand.
    `void` | `visitInvokeDynamicInsn(String name, String desc, Handle bsm, Object... bsmArgs)` Visits an invokedynamic instruction.
    `void` | `visitJumpInsn(int opcode, Label label)` Visits a jump instruction.
    `void` | `visitLabel(Label label)` Visits a label.
    `void` | `visitLdcInsn(Object cst)` Visits a LDC instruction.
    `void` | `visitLookupSwitchInsn(Label dflt, int[] keys, Label[] labels)` Visits a LOOKUPSWITCH instruction.
    `void` | `visitMethodInsn(int opcode, String owner, String name, String desc)` Deprecated.
    `void` | `visitMethodInsn(int opcode, String owner, String name, String desc, boolean itf)` Visits a method instruction.
    `void` | `visitMultiANewArrayInsn(String desc, int dims)` Visits a MULTIANEWARRAY instruction.
    `void` | `visitTableSwitchInsn(int min, int max, Label dflt, Label... labels)` Visits a TABLESWITCH instruction.
    `void` | `visitTypeInsn(int opcode, String type)` Visits a type instruction.
    `void` | `visitVarInsn(int opcode, int var)` Visits a local variable instruction.
    `void` | `xor(Type type)`

    - ### Methods inherited from class org.objectweb.asm.MethodVisitor

      `visitAnnotation, visitAnnotationDefault, visitAttribute, visitCode, visitEnd, visitFrame, visitInsnAnnotation, visitLineNumber, visitLocalVariable, visitLocalVariableAnnotation, visitMaxs, visitParameter, visitParameterAnnotation, visitTryCatchAnnotation, visitTryCatchBlock, visitTypeAnnotation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### OBJECT_TYPE

          public static final Type OBJECT_TYPE

  - ### Constructor Detail

    - #### InstructionAdapter

          public InstructionAdapter(MethodVisitor mv)

      Creates a new `InstructionAdapter`. Subclasses must not use this constructor. Instead, they must use the `InstructionAdapter(int, MethodVisitor)` version.
      Parameters:
        `mv` - the method visitor to which this adapter delegates calls.
      Throws:
        `IllegalStateException` - If a subclass calls this constructor.

    - #### InstructionAdapter

          protected InstructionAdapter(int api,
                                       MethodVisitor mv)

      Creates a new `InstructionAdapter`.
      Parameters:
        `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4` or `Opcodes.ASM5`.
        `mv` - the method visitor to which this adapter delegates calls.

  - ### Method Detail

    - #### visitInsn

          public void visitInsn(int opcode)

      Description copied from class: `MethodVisitor`
      Visits a zero operand instruction.
      Overrides:
        `visitInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the instruction to be visited. This opcode is either NOP, ACONST_NULL, ICONST_M1, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, LCONST_0, LCONST_1, FCONST_0, FCONST_1, FCONST_2, DCONST_0, DCONST_1, IALOAD, LALOAD, FALOAD, DALOAD, AALOAD, BALOAD, CALOAD, SALOAD, IASTORE, LASTORE, FASTORE, DASTORE, AASTORE, BASTORE, CASTORE, SASTORE, POP, POP2, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, SWAP, IADD, LADD, FADD, DADD, ISUB, LSUB, FSUB, DSUB, IMUL, LMUL, FMUL, DMUL, IDIV, LDIV, FDIV, DDIV, IREM, LREM, FREM, DREM, INEG, LNEG, FNEG, DNEG, ISHL, LSHL, ISHR, LSHR, IUSHR, LUSHR, IAND, LAND, IOR, LOR, IXOR, LXOR, I2L, I2F, I2D, L2I, L2F, L2D, F2I, F2L, F2D, D2I, D2L, D2F, I2B, I2C, I2S, LCMP, FCMPL, FCMPG, DCMPL, DCMPG, IRETURN, LRETURN, FRETURN, DRETURN, ARETURN, RETURN, ARRAYLENGTH, ATHROW, MONITORENTER, or MONITOREXIT.

    - #### visitIntInsn

          public void visitIntInsn(int opcode,
                                   int operand)

      Description copied from class: `MethodVisitor`
      Visits an instruction with a single int operand.
      Overrides:
        `visitIntInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the instruction to be visited. This opcode is either BIPUSH, SIPUSH or NEWARRAY.
        `operand` - the operand of the instruction to be visited.
        When opcode is BIPUSH, operand value should be between Byte.MIN_VALUE and Byte.MAX_VALUE.
        When opcode is SIPUSH, operand value should be between Short.MIN_VALUE and Short.MAX_VALUE.
        When opcode is NEWARRAY, operand value should be one of `Opcodes.T_BOOLEAN`, `Opcodes.T_CHAR`, `Opcodes.T_FLOAT`, `Opcodes.T_DOUBLE`, `Opcodes.T_BYTE`, `Opcodes.T_SHORT`, `Opcodes.T_INT` or `Opcodes.T_LONG`.

    - #### visitVarInsn

          public void visitVarInsn(int opcode,
                                   int var)

      Description copied from class: `MethodVisitor`
      Visits a local variable instruction. A local variable instruction is an instruction that loads or stores the value of a local variable.
      Overrides:
        `visitVarInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the local variable instruction to be visited. This opcode is either ILOAD, LLOAD, FLOAD, DLOAD, ALOAD, ISTORE, LSTORE, FSTORE, DSTORE, ASTORE or RET.
        `var` - the operand of the instruction to be visited. This operand is the index of a local variable.

    - #### visitTypeInsn

          public void visitTypeInsn(int opcode,
                                    String type)

      Description copied from class: `MethodVisitor`
      Visits a type instruction. A type instruction is an instruction that takes the internal name of a class as parameter.
      Overrides:
        `visitTypeInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either NEW, ANEWARRAY, CHECKCAST or INSTANCEOF.
        `type` - the operand of the instruction to be visited. This operand must be the internal name of an object or array class (see `getInternalName`).

    - #### visitFieldInsn

          public void visitFieldInsn(int opcode,
                                     String owner,
                                     String name,
                                     String desc)

      Description copied from class: `MethodVisitor`
      Visits a field instruction. A field instruction is an instruction that loads or stores the value of a field of an object.
      Overrides:
        `visitFieldInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either GETSTATIC, PUTSTATIC, GETFIELD or PUTFIELD.
        `owner` - the internal name of the field's owner class (see `getInternalName`).
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).

    - #### visitMethodInsn

          @Deprecated
          public void visitMethodInsn(int opcode,
                                                   String owner,
                                                   String name,
                                                   String desc)

      Deprecated.
      Description copied from class: `MethodVisitor`
      Visits a method instruction. A method instruction is an instruction that invokes a method.
      Overrides:
        `visitMethodInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
        `owner` - the internal name of the method's owner class (see `getInternalName`).
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).

    - #### visitMethodInsn

          public void visitMethodInsn(int opcode,
                                      String owner,
                                      String name,
                                      String desc,
                                      boolean itf)

      Description copied from class: `MethodVisitor`
      Visits a method instruction. A method instruction is an instruction that invokes a method.
      Overrides:
        `visitMethodInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
        `owner` - the internal name of the method's owner class (see `getInternalName`).
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `itf` - if the method's owner class is an interface.

    - #### visitInvokeDynamicInsn

          public void visitInvokeDynamicInsn(String name,
                                             String desc,
                                             Handle bsm,
                                             Object... bsmArgs)

      Description copied from class: `MethodVisitor`
      Visits an invokedynamic instruction.
      Overrides:
        `visitInvokeDynamicInsn` in class `MethodVisitor`
      Parameters:
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `bsm` - the bootstrap method.
        `bsmArgs` - the bootstrap method constant arguments. Each argument must be an `Integer`, `Float`, `Long`, `Double`, `String`, `Type` or `Handle` value. This method is allowed to modify the content of the array so a caller should expect that this array may change.

    - #### visitJumpInsn

          public void visitJumpInsn(int opcode,
                                    Label label)

      Description copied from class: `MethodVisitor`
      Visits a jump instruction. A jump instruction is an instruction that may jump to another instruction.
      Overrides:
        `visitJumpInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either IFEQ, IFNE, IFLT, IFGE, IFGT, IFLE, IF_ICMPEQ, IF_ICMPNE, IF_ICMPLT, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ACMPEQ, IF_ACMPNE, GOTO, JSR, IFNULL or IFNONNULL.
        `label` - the operand of the instruction to be visited. This operand is a label that designates the instruction to which the jump instruction may jump.

    - #### visitLabel

          public void visitLabel(Label label)

      Description copied from class: `MethodVisitor`
      Visits a label. A label designates the instruction that will be visited just after it.
      Overrides:
        `visitLabel` in class `MethodVisitor`
      Parameters:
        `label` - a `Label` object.

    - #### visitLdcInsn

          public void visitLdcInsn(Object cst)

      Description copied from class: `MethodVisitor`
      Visits a LDC instruction. Note that new constant types may be added in future versions of the Java Virtual Machine. To easily detect new constant types, implementations of this method should check for unexpected constant types, like this:

           if (cst instanceof Integer) {
               // ...
           } else if (cst instanceof Float) {
               // ...
           } else if (cst instanceof Long) {
               // ...
           } else if (cst instanceof Double) {
               // ...
           } else if (cst instanceof String) {
               // ...
           } else if (cst instanceof Type) {
               int sort = ((Type) cst).getSort();
               if (sort == Type.OBJECT) {
                   // ...
               } else if (sort == Type.ARRAY) {
                   // ...
               } else if (sort == Type.METHOD) {
                   // ...
               } else {
                   // throw an exception
               }
           } else if (cst instanceof Handle) {
               // ...
           } else {
               // throw an exception
           }

      Overrides:
        `visitLdcInsn` in class `MethodVisitor`
      Parameters:
        `cst` - the constant to be loaded on the stack. This parameter must be a non null `Integer`, a `Float`, a `Long`, a `Double`, a `String`, a `Type` of OBJECT or ARRAY sort for `.class` constants, for classes whose version is 49.0, a `Type` of METHOD sort or a `Handle` for MethodType and MethodHandle constants, for classes whose version is 51.0.

    - #### visitIincInsn

          public void visitIincInsn(int var,
                                    int increment)

      Description copied from class: `MethodVisitor`
      Visits an IINC instruction.
      Overrides:
        `visitIincInsn` in class `MethodVisitor`
      Parameters:
        `var` - index of the local variable to be incremented.
        `increment` - amount to increment the local variable by.

    - #### visitTableSwitchInsn

          public void visitTableSwitchInsn(int min,
                                           int max,
                                           Label dflt,
                                           Label... labels)

      Description copied from class: `MethodVisitor`
      Visits a TABLESWITCH instruction.
      Overrides:
        `visitTableSwitchInsn` in class `MethodVisitor`
      Parameters:
        `min` - the minimum key value.
        `max` - the maximum key value.
        `dflt` - beginning of the default handler block.
        `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `min + i` key.

    - #### visitLookupSwitchInsn

          public void visitLookupSwitchInsn(Label dflt,
                                            int[] keys,
                                            Label[] labels)

      Description copied from class: `MethodVisitor`
      Visits a LOOKUPSWITCH instruction.
      Overrides:
        `visitLookupSwitchInsn` in class `MethodVisitor`
      Parameters:
        `dflt` - beginning of the default handler block.
        `keys` - the values of the keys.
        `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `keys[i]` key.

    - #### visitMultiANewArrayInsn

          public void visitMultiANewArrayInsn(String desc,
                                              int dims)

      Description copied from class: `MethodVisitor`
      Visits a MULTIANEWARRAY instruction.
      Overrides:
        `visitMultiANewArrayInsn` in class `MethodVisitor`
      Parameters:
        `desc` - an array type descriptor (see `Type`).
        `dims` - number of dimensions of the array to allocate.

    - #### nop

          public void nop()

    - #### aconst

          public void aconst(Object cst)

    - #### iconst

          public void iconst(int cst)

    - #### lconst

          public void lconst(long cst)

    - #### fconst

          public void fconst(float cst)

    - #### dconst

          public void dconst(double cst)

    - #### tconst

          public void tconst(Type type)

    - #### hconst

          public void hconst(Handle handle)

    - #### load

          public void load(int var,
                           Type type)

    - #### aload

          public void aload(Type type)

    - #### store

          public void store(int var,
                            Type type)

    - #### astore

          public void astore(Type type)

    - #### pop

          public void pop()

    - #### pop2

          public void pop2()

    - #### dup

          public void dup()

    - #### dup2

          public void dup2()

    - #### dupX1

          public void dupX1()

    - #### dupX2

          public void dupX2()

    - #### dup2X1

          public void dup2X1()

    - #### dup2X2

          public void dup2X2()

    - #### swap

          public void swap()

    - #### add

          public void add(Type type)

    - #### sub

          public void sub(Type type)

    - #### mul

          public void mul(Type type)

    - #### div

          public void div(Type type)

    - #### rem

          public void rem(Type type)

    - #### neg

          public void neg(Type type)

    - #### shl

          public void shl(Type type)

    - #### shr

          public void shr(Type type)

    - #### ushr

          public void ushr(Type type)

    - #### and

          public void and(Type type)

    - #### or

          public void or(Type type)

    - #### xor

          public void xor(Type type)

    - #### iinc

          public void iinc(int var,
                           int increment)

    - #### cast

          public void cast(Type from,
                           Type to)

    - #### lcmp

          public void lcmp()

    - #### cmpl

          public void cmpl(Type type)

    - #### cmpg

          public void cmpg(Type type)

    - #### ifeq

          public void ifeq(Label label)

    - #### ifne

          public void ifne(Label label)

    - #### iflt

          public void iflt(Label label)

    - #### ifge

          public void ifge(Label label)

    - #### ifgt

          public void ifgt(Label label)

    - #### ifle

          public void ifle(Label label)

    - #### ificmpeq

          public void ificmpeq(Label label)

    - #### ificmpne

          public void ificmpne(Label label)

    - #### ificmplt

          public void ificmplt(Label label)

    - #### ificmpge

          public void ificmpge(Label label)

    - #### ificmpgt

          public void ificmpgt(Label label)

    - #### ificmple

          public void ificmple(Label label)

    - #### ifacmpeq

          public void ifacmpeq(Label label)

    - #### ifacmpne

          public void ifacmpne(Label label)

    - #### goTo

          public void goTo(Label label)

    - #### jsr

          public void jsr(Label label)

    - #### ret

          public void ret(int var)

    - #### tableswitch

          public void tableswitch(int min,
                                  int max,
                                  Label dflt,
                                  Label... labels)

    - #### lookupswitch

          public void lookupswitch(Label dflt,
                                   int[] keys,
                                   Label[] labels)

    - #### areturn

          public void areturn(Type t)

    - #### getstatic

          public void getstatic(String owner,
                                String name,
                                String desc)

    - #### putstatic

          public void putstatic(String owner,
                                String name,
                                String desc)

    - #### getfield

          public void getfield(String owner,
                               String name,
                               String desc)

    - #### putfield

          public void putfield(String owner,
                               String name,
                               String desc)

    - #### invokevirtual

          @Deprecated
          public void invokevirtual(String owner,
                                                 String name,
                                                 String desc)

      Deprecated.

    - #### invokevirtual

          public void invokevirtual(String owner,
                                    String name,
                                    String desc,
                                    boolean itf)

    - #### invokespecial

          @Deprecated
          public void invokespecial(String owner,
                                                 String name,
                                                 String desc)

      Deprecated.

    - #### invokespecial

          public void invokespecial(String owner,
                                    String name,
                                    String desc,
                                    boolean itf)

    - #### invokestatic

          @Deprecated
          public void invokestatic(String owner,
                                                String name,
                                                String desc)

      Deprecated.

    - #### invokestatic

          public void invokestatic(String owner,
                                   String name,
                                   String desc,
                                   boolean itf)

    - #### invokeinterface

          public void invokeinterface(String owner,
                                      String name,
                                      String desc)

    - #### invokedynamic

          public void invokedynamic(String name,
                                    String desc,
                                    Handle bsm,
                                    Object[] bsmArgs)

    - #### anew

          public void anew(Type type)

    - #### newarray

          public void newarray(Type type)

    - #### arraylength

          public void arraylength()

    - #### athrow

          public void athrow()

    - #### checkcast

          public void checkcast(Type type)

    - #### instanceOf

          public void instanceOf(Type type)

    - #### monitorenter

          public void monitorenter()

    - #### monitorexit

          public void monitorexit()

    - #### multianewarray

          public void multianewarray(String desc,
                                     int dims)

    - #### ifnull

          public void ifnull(Label label)

    - #### ifnonnull

          public void ifnonnull(Label label)

    - #### mark

          public void mark(Label label)